#pragma once

#include "entity.hpp"
#include "static_mesh.hpp"
#include "math_types.hpp"

#include <memory>

class Enemy
: public Entity
{
public:

    Enemy();
    ~Enemy();

    void SetStaticMesh(StaticMesh const & mesh);
    void SetViewProjection(Matrix const & vp);
    void Process(float deltaTime, class Input * pInput) override;
    void Draw();

    Vector const & GetPosition() const;
    void SetPosition(Vector const & position);

    void SetTarget(class Player * target);

private:

    enum Behaviour
    {
        Wander,
        Pursue,
        Attack,
        Flee
    };
    
    StaticMesh staticMesh;
    Matrix vp;
    Vector position;
    Vector direction;
    float orientation;

    class Player * target;
    Behaviour behaviour;
    float timer;
};