#pragma once

#include "entity.hpp"
#include "static_mesh.hpp"
#include "math_types.hpp"

#include <memory>

class Player
: public Entity
{
public:

    Player();
    ~Player();

    void SetStaticMesh(StaticMesh const & mesh);
    void SetViewProjection(Matrix const & vp);
    void Process(float deltaTime, class Input * pInput) override;
    void Draw();

    Vector const & GetPosition() const;
    void SetPosition(Vector const & position);

private:

    StaticMesh staticMesh;
    Matrix vp;
    Vector position;
    float orientation;
};