#pragma once

#include "entity.hpp"
#include "mesh.hpp"
#include "math_types.hpp"

#include <memory>

typedef std::shared_ptr<Mesh> tSharedMesh;

class StaticMesh
: public Entity
{
public:

    StaticMesh();
    ~StaticMesh();

    static StaticMesh LoadFromFile(std::string const & sMeshFile,
                                   std::string const & sTextureFile,
                                   uint32_t width,
                                   uint32_t height);

    void SetMesh(tSharedMesh mesh);
    void SetTexture(void * texture, uint32_t width, uint32_t height);

    void SetTransform(Matrix const & transform);

    void Process(float deltaTime, class Input * pInput) override;
    void Draw();

private:

    void * texture;
    tSharedMesh mesh;
    uint32_t textureWidth, textureHeight;
    Matrix transform;
};