#pragma once

#include <vector>
#include <map>

#include "entity.hpp"
#include "entities/static_mesh.hpp"
#include "entities/player.hpp"
#include "entities/enemy.hpp"
#include "math_types.hpp"
#include "mesh.hpp"
#include "entities/camera.hpp"

class GameJamGame
: public Entity
{
public:

    GameJamGame();
    ~GameJamGame();

    void Reload();

    void Process(float deltaTime, class Input * pInput) override;
    void Draw();

private:

    StaticMesh LoadStaticMesh(std::string const & sMeshName,
                                     std::string const & sMeshFile,
                                     std::string const & sTextureFile,
                                     uint32_t textureWidth,
                                     uint32_t textureHeight);

    void * LoadTexture(std::string const & sTextureFile,
                       uint32_t textureWidth,
                       uint32_t textureHeight);

    enum State
    {
        TitleScreen,
        Gameplay
    };

    State state;

    void * titleScreen;

    Camera camera;
    StaticMesh dungeon;
    Player ross;
    std::vector<Enemy> enemies;

    std::map <std::string, StaticMesh> staticMeshes;
    std::map <std::string, void *> textures;
};