#pragma once

#include "Entity.hpp"
#include "math_types.hpp"
#include "mesh.hpp"

class SkeletalMeshTest
: public Entity
{
public:

    SkeletalMeshTest();
    ~SkeletalMeshTest();

    void Process(float deltaTime, class Input * pInput) override;
    void Draw();

private:

    enum QuadRenderMode
    {
        first = 0,
        second,
        third,
        all,
        maxQuadRenderMode
    };

    enum SkinningMode
    {
        eNoSkinning,
        eInverseBindPose,
        eSkinned,
        maxSkinningMode
    };

    tQuads quads;

    class Joint * pBindPoseRoot;
    class Joint * pDynamicPoseRoot;

    float firstAngle, secondAngle;
    float aPress, bPress;

    QuadRenderMode quadRenderMode;
    SkinningMode skinningMode;
    void * thumbs_up;

    Mesh mesh;
};